/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AtomIdValidator.cpp
 *
 *  Created on: May 14, 2012
 *      Author: ankele
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "AtomIdValidator.hpp"

#include "Descriptors/AtomIdDescriptor.hpp"
#include "World.hpp"

bool AtomIdValidator::isValid(const atomId_t & _value) const
{
  return (const_cast<const World &>(World::getInstance()).getAtom(AtomById(_value)) != NULL);
}

bool AtomIdValidator::operator==(const Validator<atomId_t> &_instance) const
{
  const AtomIdValidator *inst =
      dynamic_cast<const AtomIdValidator *>(&_instance);
  if (inst)
    return true;
  else
    return false;
}

Validator< atomId_t >* AtomIdValidator::clone() const
{
  Validator< atomId_t > *inst =
      new AtomIdValidator();
  return inst;
}




